#include <xc.h>

#include "system.h"
#include "usb_device.h"
#include "usb_device_midi.h"
#include "inputs.h"
#include "outputs.h"
#include "midi.h"
#include "encoder.h"
#include "usb_ch9.h"
#include "adc.h"

#define _XTAL_FREQ 20000000

void main(void)
{
    SYSTEM_Initialize(SYSTEM_STATE_USB_START);

    USBDeviceInit();
    USBDeviceAttach();
    
    while(1)
    {
        SYSTEM_Tasks();

        #if defined(USB_POLLING)
            // function does not take very long to execute (ex: <100 instruction cycles) before it returns.
            USBDeviceTasks();
        #endif

        // Process received MIDI packet if any are there
        processReceivedMIDI();
        
        procesAnalogInputs(ADC_CHANEL);
        
        getButtons();
        
        procesEncoder();
        
        procesJogWheel();
        
        sendButtons();
        
        setLeds();
    }
}











